
TYPO3.Neos - Task # 45531

Work Package # 45020 (Closed): Content Editing Stability and Features

Status: Closed Priority: Must have
Author: Adrian Föder Category:
Created: 2013-02-16 Assigned To: Tim Kandel
Updated: 2014-11-02 Due date:
Subject: In Backend, handle exceptions more gracefully if possible
Description

As soon as an exception occurs, it's displayed and the whole backend halts with no way to escape.

As an example, we removed a declaration in TypoScript regarding the plugin implementations of TYPO3.MailForm; such a plugin
node was however still present. This resulted in the correct exception

#1332493995: The TypoScript object at path
"page<TYPO3.Neos.ContentTypes:Page>/body<TYPO3.TypoScript:Template>/sections/main<TYPO3.Neos.ContentTypes:Section>/default<TYPO3.TypoScript:Matcher>/el
ction>/default<TYPO3.TypoScript:Matcher>/element<TYPO3.Neos.ContentTypes:Section.Default>/itemRenderer<TYPO3.TypoScript:Case>/default<TYPO3.TypoScript:Matcher>/element<TYPO3.MailForm:Plugin>" could not be rendered: Missing implementation class name for "TYPO3.Mai
oScript:Case>/default<TYPO3.TypoScript:Matcher>/element<TYPO3.MailForm:Plugin>" could not be rendered: Missing
implementation class name for "TYPO3.MailForm:Plugin". Add @class in your TypoScript configuration. (More information)

Although this is correct; this exception should rather occur as an inline note or something like that; giving the opportunity to finally
delete the node or whatever.

Related issues:
related to TYPO3.Neos - Bug # 42733: It is not possible to interact with a pl... Closed 2012-11-06

Associated revisions
Revision 81383c8e - 2013-07-06 22:23 - Tim Kandel

[TASK] Change the TS exception handling to allow more options

Adjusts the PluginImplementation and the ContentElementViewHelper to use the
newly implemented Exception handling to allow removing the element if an
error occured.

Change-Id: I608dc27c712229c52932c46df7f7dee9223ee4a4
Related: #45531
Reviewed-on: https://review.typo3.org/22031
Reviewed-by: Tim Kandel
Tested-by: Tim Kandel
Reviewed-by: Sebastian Kurfuerst
Tested-by: Sebastian Kurfuerst

Revision b5b28414 - 2013-10-30 14:07 - Christoph Dähne 

[BUGFIX] Graceful degradation of broken content elements

If content elements cannot be rendered for some reason, an error message
is displayed instead of the actual content. The broken elements can
still be (un)hidden, copy-pasted, … and even published.

Some errors are not yet covered yet, like not existing Node-Types.
In this case the error message is displayed without the option to hide,
remove, cut or copy the broken element.
There is already a request for this Feature #52511.

The css-styles of the Neos backend do not apply to published, broken
content elements, but can be customized.

The TypoScript object type TYPO3.Neos:Template declares the
@exceptionHandler property to handle rendering exceptions with a special
handler that wraps nodes with the content element wrapping services.

Resolves: #45531
Change-Id: Iddd7b254e352b7960919bfc0c25321e2a38660e4
Reviewed-on: https://review.typo3.org/24239
Reviewed-by: Christopher Hlubek
Tested-by: Christopher Hlubek
Reviewed-by: Sebastian Kurfuerst
Tested-by: Sebastian Kurfuerst

History
#1 - 2013-04-10 21:31 - Aske Ertmann
- Status changed from New to Accepted

We should handle these exceptions with a default error text with proper information about the issue, there is however an issue about when a real
exception should be thrown and when it should be handled gracefully. I'd say if it's not live workspace, handle the exception gracefully. It would be very
nice if we could reference a system logging module for the error description, but we need to create that before we can do so.

#2 - 2013-05-15 22:17 - Tim Kandel
- Assigned To set to Tim Kandel

#3 - 2013-05-17 13:24 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20866

#4 - 2013-05-17 17:44 - Tim Kandel
- Status changed from Accepted to Under Review
- % Done changed from 0 to 100

#5 - 2013-05-21 13:57 - Adrian Föder
- Tracker changed from Bug to Task
- Category deleted (UI)

#6 - 2013-08-09 16:52 - Karsten Dambekalns
- Status changed from Under Review to Resolved
#7 - 2013-10-02 15:22 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#8 - 2013-10-02 16:33 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#9 - 2013-10-03 10:57 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#10 - 2013-10-03 11:23 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#11 - 2013-10-03 13:17 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#12 - 2013-10-03 14:07 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#13 - 2013-10-03 16:13 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#14 - 2013-10-03 16:32 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#15 - 2013-10-29 22:59 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#16 - 2013-10-29 23:00 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#17 - 2013-10-30 11:10 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#18 - 2013-10-30 11:18 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#19 - 2013-10-30 11:20 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#20 - 2013-10-30 11:54 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#21 - 2013-10-30 12:10 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#22 - 2013-10-30 13:11 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24239

#23 - 2013-10-30 13:52 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24224

#24 - 2013-10-30 14:36 - Anonymous
- Status changed from Under Review to Resolved
Applied in changeset commit:b5b28414274cfb00c7b378847f8ea1e60c6f93f5.

#25 - 2014-11-02 18:22 - Aske Ertmann
- Status changed from Resolved to Closed
